=== debian/changelog ===
brewtarget (2.0.2-1) unstable; urgency=low

  * New upstream release
  * Updated copyright years.
  * Changed references from sourceforge.net to brewtarget.org.
  * Bumped standards-version to 3.9.5.
  * Requires debhelper > 9.0.

 -- Philip G. Lee <rocketman768@gmail.com>  Sat, 11 Jan 2014 15:08:30 -0600

brewtarget (2.0.1-1) unstable; urgency=low

  * New upstream release
  * Now importing hardening flags.
  * Updated standards version to 3.9.4.
  * Updated compat to 9
  * Added libqtwebkit-dev to the build dependencies. 

 -- Philip G. Lee <rocketman768@gmail.com>  Mon, 17 Mar 2013 20:41:21 -0600

brewtarget (2.0.0-1) unstable; urgency=low

  * New upstream release

 -- Philip G. Lee <rocketman768@gmail.com>  Sat, 29 Dec 2012 09:02:42 -0500
