=== debian/control ===
Source: brewtarget
Section: misc
Priority: optional
Maintainer: Philip G. Lee <rocketman768@gmail.com>
Build-Depends: cmake (>= 2.8), debhelper (>= 9.0), autotools-dev, libqt4-dev, qt4-qmake, libphonon-dev, libqtwebkit-dev, sqlite3, hardening-includes
Standards-Version: 3.9.5
Homepage: http://www.brewtarget.org

Package: brewtarget
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt4-sql-sqlite
Description: GUI beer brewing software
 Brewtarget is a calculator for brewing beer. It is a Qt-based program which
 allows you to create recipes from a database of ingredients. It calculates all
 the important parameters, helps you with mash temperatures, and just makes the
 process of recipe formulation much easier.
