=== debian/rules ===
#!/usr/bin/make -f
install-dir = "$(shell pwd)/debian/brewtarget"
include /usr/share/hardening-includes/hardening.make

CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
CXXFLAGS+=$(HARDENING_CFLAGS)
LDFLAGS+=$(HARDENING_LDFLAGS)

override_dh_auto_configure:
	if ! test -d build; then mkdir build; fi
	if ! test -d build/cmake; then mkdir build/cmake; fi
	cd build/cmake; \
	cmake ../../ -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" -DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" -DDO_RELEASE_BUILD=ON -DNO_MESSING_WITH_FLAGS=ON -DCMAKE_INSTALL_PREFIX=$(install-dir) -DEXEC_PREFIX=usr

override_dh_auto_build:
	cd build/cmake; \
	make

override_dh_auto_install:
	cd build/cmake; \
	make install

override_dh_clean:
	dh_clean
	if test -d build/cmake; then rm -r build/cmake; fi
	if test -e src/config.h; then rm src/config.h; fi
	if test -d debian/brewtarget; then rm -r debian/brewtarget; fi

%:
	dh $@
