## brewtarget 2.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 PROJECT(brewtarget)
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 2.8.8)
 
 # Creates a Makefile.
 # NOTE: cmake . -DCMAKE_INSTALL_PREFIX=/tmp/blah && make DESTDIR=/foo
@@ -10,8 +10,8 @@
 
 #=================================Version======================================
 SET( brewtarget_VERSION_MAJOR 2 )
-SET( brewtarget_VERSION_MINOR 0 )
-SET( brewtarget_VERSION_PATCH 2 )
+SET( brewtarget_VERSION_MINOR 1 )
+SET( brewtarget_VERSION_PATCH 0 )
 SET( brewtarget_VERSION_STRING "${brewtarget_VERSION_MAJOR}.${brewtarget_VERSION_MINOR}.${brewtarget_VERSION_PATCH}" )
 
 #===================================Options====================================
@@ -30,6 +30,10 @@
 OPTION( NO_MESSING_WITH_FLAGS
         "On means do not add any build flags whatsoever. May override other options."
         OFF )
+
+# Do this right off the bat
+ENABLE_TESTING()
+
 #==============================Compile flags===================================
 IF( NOT ${NO_MESSING_WITH_FLAGS} )
    IF( CMAKE_COMPILER_IS_GNUCXX )
@@ -59,7 +63,8 @@
 ENDIF()
 
 IF( APPLE AND NOT CMAKE_OSX_ARCHITECTURES )
-   SET( CMAKE_OSX_ARCHITECTURES i386 x86_64 ) # Build intel binary. 
+   SET( CMAKE_OSX_ARCHITECTURES x86_64 ) # Build intel 64-bit binary. 
+   #SET( CMAKE_OSX_ARCHITECTURES i386 x86_64 ) # Build intel binary. 
    #SET( CMAKE_OSX_ARCHITECTURES ppc i386 ppc64 x86_64 ) # Build universal binary.
 ENDIF()
 
@@ -89,9 +94,15 @@
 
 # ======================Find Qt4 (>= 4.6.0) for this project===================
 IF( ${BUILD_DESIGNER_PLUGINS} )
-   FIND_PACKAGE(Qt4 4.6.0 COMPONENTS QtCore QtGui QtNetwork QtSql QtSvg QtWebKit QtXml QtDesigner REQUIRED)
+   FIND_PACKAGE(Qt4 4.6.0 COMPONENTS QtCore QtGui QtNetwork QtSql QtWebKit QtXml QtDesigner REQUIRED)
 ELSE()
-   FIND_PACKAGE(Qt4 4.6.0 COMPONENTS QtCore QtGui QtNetwork QtSql QtSvg QtWebkit QtXml REQUIRED)
+   # This is a major kludge, but linking with QtSvg is the easiest way to get
+   # an app that includes the svg image format plugin that works.
+   IF( APPLE )
+      FIND_PACKAGE(Qt4 4.6.0 COMPONENTS QtCore QtGui QtNetwork QtSql QtWebkit QtXml QtSvg REQUIRED)
+   ELSE()
+      FIND_PACKAGE(Qt4 4.6.0 COMPONENTS QtCore QtGui QtNetwork QtSql QtWebkit QtXml REQUIRED)
+   ENDIF()
 ENDIF()
 
 MESSAGE( STATUS "CMAKE_SYSTEM_INCLUDE_PATH: ${CMAKE_SYSTEM_INCLUDE_PATH}" )
@@ -120,8 +131,6 @@
 #=========================Configure brewtarget.qrc.in==========================
 
 SET( brewtarget_QRC "${CMAKE_CURRENT_SOURCE_DIR}/brewtarget.qrc" )
-SET( brewtarget_cfg_QRC "${CMAKE_CURRENT_BINARY_DIR}/brewtarget_cfg.qrc" )
-CONFIGURE_FILE( brewtarget_cfg.qrc.in ${brewtarget_cfg_QRC} )
 
 #============================Doxygen Custom Target=============================
 FIND_PROGRAM( DOXYGEN_CMD doxygen )
@@ -132,12 +141,6 @@
                      COMMAND ${DOXYGEN_CMD} ${DOXYFILE}
                      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/doc"
                    )
-ENDIF()
-
-#=============================Database Custom Target===========================
-FIND_PROGRAM( SQLITE3_CMD sqlite3 )
-IF( NOT SQLITE3_CMD )
-   MESSAGE( FATAL_ERROR "Did not find sqlite3 to make the database." )
 ENDIF()
 
 #=========================Detect Debian======================================== 
@@ -192,17 +195,6 @@
   SET( DOCPATH  "${BT_BUNDLE_DIR}/Contents/Resources/en.lproj" )
 ENDIF()
 
-#=========================Configure brewtarget.desktop=========================
-
-# If it begins with a '/'
-IF( IS_ABSOLUTE ${DATAROOTDIR} )
-   SET( brewtarget_ICONS_LOCATION "${DATAROOTDIR}/icons/${CMAKE_PROJECT_NAME}" )
-ELSE()
-   SET( brewtarget_ICONS_LOCATION "/${DATAROOTDIR}/icons/${CMAKE_PROJECT_NAME}" )
-ENDIF()
-
-CONFIGURE_FILE( brewtarget.desktop.in brewtarget.desktop )
-
 #==============================Setup the config.h==============================
 
 # "#define CONFIGDATADIR ${CONFIGDATADIR}$" in config.in will be replaced
@@ -237,22 +229,19 @@
 # List of data files to be installed.
 SET( brewtarget_DATA
      ${DATADIR}/default_db.sqlite
-     ${DATADIR}/options.xml
 # Yes, I know this is 'documentation', but Debian policy suggests it should be
 # with the data (see section 12.3 of the policy manual).
      ${ROOTDIR}/doc/brewtarget-manual.html
 )
 
 # Desktop files to install.
-# This is not prefixed with ${ROOTDIR} b/c it is a configured file that will
-# only exist in the build directory.
 SET( brewtarget_DESKTOP
-     ${CMAKE_CURRENT_BINARY_DIR}/brewtarget.desktop
+     ${ROOTDIR}/brewtarget.desktop
 )
 
 # Icon files to install.
 SET( brewtarget_ICONS
-     ${ROOTDIR}/images/brewtarget_icon.svg
+     ${ROOTDIR}/images/brewtarget.svg
 )
 
 SET( TRANSLATIONS_FILES
@@ -348,3 +337,19 @@
    # Find extra MinGW-specific dlls.
    IF( MINGW )
       IF( NOT MINGW_BIN_DIR )
+         FIND_PATH(MINGW_BIN_DIR "mingw32-c++.exe")
+      ENDIF()
+     
+     IF( NOT EXISTS ${MINGW_BIN_DIR} )
+        MESSAGE( FATAL_ERROR "MinGW bin dir not found. Run cmake again with the option -DMINGW_BIN_DIR=c:/path/to/mingw" )
+     ELSE()
+        SET( Qt_DLLs
+             ${Qt_DLLs}
+             ${MINGW_BIN_DIR}/libgcc_s_dw2-1.dll
+             ${MINGW_BIN_DIR}/libstdc++-6.dll
+             ${MINGW_BIN_DIR}/mingwm10.dll
+        )
+     ENDIF()
+   ENDIF()
+ENDIF()
+
