=== src/CMakeLists.txt ===
--- 
+++ 
@@ -60,22 +60,24 @@
     ${SRCDIR}/BrewDayScrollWidget.cpp
     ${SRCDIR}/brewnote.cpp
     ${SRCDIR}/BrewNoteWidget.cpp
-    ${SRCDIR}/BrewTargetTreeItem.cpp
-    ${SRCDIR}/BrewTargetTreeModel.cpp
-    ${SRCDIR}/BrewTargetTreeView.cpp
+    ${SRCDIR}/BtTabWidget.cpp
+    ${SRCDIR}/BtTreeItem.cpp
+    ${SRCDIR}/BtTreeModel.cpp
+    ${SRCDIR}/BtTreeView.cpp
     ${SRCDIR}/BtTreeFilterProxyModel.cpp
     ${SRCDIR}/BeerColorWidget.cpp
     ${SRCDIR}/BtDatePopup.cpp
+    ${SRCDIR}/BtFolder.cpp
     ${SRCDIR}/BtLabel.cpp
     ${SRCDIR}/BtTextEdit.cpp
     ${SRCDIR}/brewtarget.cpp
     ${SRCDIR}/BtSplashScreen.cpp
-    #${SRCDIR}/BtSqlQuery.cpp
     ${SRCDIR}/CelsiusTempUnitSystem.cpp
     ${SRCDIR}/ColorMethods.cpp
     ${SRCDIR}/ConverterTool.cpp
     ${SRCDIR}/CustomComboBox.cpp
     ${SRCDIR}/database.cpp
+    ${SRCDIR}/DatabaseSchemaHelper.cpp
     ${SRCDIR}/equipment.cpp
     ${SRCDIR}/EquipmentButton.cpp
     ${SRCDIR}/EquipmentListModel.cpp
@@ -86,7 +88,6 @@
     ${SRCDIR}/FermentableDialog.cpp
     ${SRCDIR}/FermentableSortFilterProxyModel.cpp
     ${SRCDIR}/FermentableTableModel.cpp
-    ${SRCDIR}/main.cpp
     ${SRCDIR}/HeatCalculations.cpp
     ${SRCDIR}/hop.cpp
     ${SRCDIR}/HopDialog.cpp
@@ -94,11 +95,11 @@
     ${SRCDIR}/HopSortFilterProxyModel.cpp
     ${SRCDIR}/HopTableModel.cpp
     ${SRCDIR}/instruction.cpp
+    ${SRCDIR}/IbuGuSlider.cpp
     ${SRCDIR}/IbuMethods.cpp
     ${SRCDIR}/ImperialVolumeUnitSystem.cpp
     ${SRCDIR}/InstructionWidget.cpp
     ${SRCDIR}/MainWindow.cpp
-    ${SRCDIR}/MaltinessWidget.cpp
     ${SRCDIR}/mash.cpp
     ${SRCDIR}/MashButton.cpp
     ${SRCDIR}/MashEditor.cpp
@@ -120,19 +121,21 @@
     ${SRCDIR}/PreInstruction.cpp
     ${SRCDIR}/PrimingDialog.cpp
     ${SRCDIR}/QueuedMethod.cpp
+    ${SRCDIR}/RangedSlider.cpp
     ${SRCDIR}/recipe.cpp
     ${SRCDIR}/RecipeFormatter.cpp
-    ${SRCDIR}/RecipeListModel.cpp
     ${SRCDIR}/RefractoDialog.cpp
     ${SRCDIR}/SetterCommand.cpp
     ${SRCDIR}/SetterCommandStack.cpp
     ${SRCDIR}/ScaleRecipeTool.cpp
     ${SRCDIR}/SIVolumeUnitSystem.cpp
     ${SRCDIR}/SIWeightUnitSystem.cpp
+    ${SRCDIR}/StrikeWaterDialog.cpp
     ${SRCDIR}/style.cpp
     ${SRCDIR}/StyleButton.cpp
     ${SRCDIR}/StyleListModel.cpp
     ${SRCDIR}/StyleEditor.cpp
+    ${SRCDIR}/StyleRangeWidget.cpp
     ${SRCDIR}/StyleSortFilterProxyModel.cpp
     ${SRCDIR}/TimerListDialog.cpp
     ${SRCDIR}/TimerWidget.cpp
@@ -188,6 +191,7 @@
     ${UIDIR}/recipeExtrasDialog.ui
     ${UIDIR}/refractoDialog.ui
     ${UIDIR}/scaleRecipeTool.ui
+    ${UIDIR}/strikeWaterDialog.ui
     ${UIDIR}/styleEditor.ui
     ${UIDIR}/timerListDialog.ui
     ${UIDIR}/timerWidget.ui
@@ -211,15 +215,16 @@
     ${SRCDIR}/brewnote.h
     ${SRCDIR}/BrewNoteWidget.h
     ${SRCDIR}/brewtarget.h
-    ${SRCDIR}/BrewTargetTreeModel.h
-    ${SRCDIR}/BrewTargetTreeView.h
+    ${SRCDIR}/BtTabWidget.h
+    ${SRCDIR}/BtTreeModel.h
+    ${SRCDIR}/BtTreeView.h
     ${SRCDIR}/BtTreeFilterProxyModel.h
     ${SRCDIR}/BtDigitWidget.h
     ${SRCDIR}/BtDatePopup.h
+    ${SRCDIR}/BtFolder.h
     ${SRCDIR}/BtLabel.h
     ${SRCDIR}/BtTextEdit.h
     ${SRCDIR}/BtSplashScreen.h
-    #${SRCDIR}/BtSqlQuery.h
     ${SRCDIR}/ConverterTool.h
     ${SRCDIR}/CustomComboBox.h
     ${SRCDIR}/database.h
@@ -234,9 +239,9 @@
     ${SRCDIR}/HopEditor.h
     ${SRCDIR}/HopSortFilterProxyModel.h
     ${SRCDIR}/HopTableModel.h
+    ${SRCDIR}/IbuGuSlider.h
     ${SRCDIR}/InstructionWidget.h
     ${SRCDIR}/MainWindow.h
-    ${SRCDIR}/MaltinessWidget.h
     ${SRCDIR}/MashButton.h
     ${SRCDIR}/MashDesigner.h
     ${SRCDIR}/MashEditor.h
@@ -255,16 +260,18 @@
     ${SRCDIR}/PitchDialog.h
     ${SRCDIR}/PrimingDialog.h
     ${SRCDIR}/QueuedMethod.h
+    ${SRCDIR}/RangedSlider.h
     ${SRCDIR}/RecipeExtrasDialog.h
     ${SRCDIR}/RecipeExtrasWidget.h
     ${SRCDIR}/RecipeFormatter.h
-    ${SRCDIR}/RecipeListModel.h
     ${SRCDIR}/RefractoDialog.h
     ${SRCDIR}/ScaleRecipeTool.h
     ${SRCDIR}/SetterCommandStack.h
+    ${SRCDIR}/StrikeWaterDialog.h
     ${SRCDIR}/StyleButton.h
     ${SRCDIR}/StyleListModel.h
     ${SRCDIR}/StyleEditor.h
+    ${SRCDIR}/StyleRangeWidget.h
     ${SRCDIR}/StyleSortFilterProxyModel.h
     ${SRCDIR}/TimerListDialog.h
     ${SRCDIR}/TimerWidget.h
@@ -302,17 +309,6 @@
 #   ENDFOREACH()
 #ENDIF()
 
-#======================Some Custom Targets/Commands============================
-
-# Creates a target for ${CMAKE_CURRENT_BINARY_DIR}/blankdb.sqlite needed by
-# the brewtarget.qrc resource file.
-ADD_CUSTOM_COMMAND( OUTPUT blankdb.sqlite
-                    COMMAND ${RM_COMMAND} ARGS ${RM_ARGS} "blankdb.sqlite" # Need to remove it if it exists first.
-                    COMMAND ${SQLITE3_CMD} ARGS "blankdb.sqlite" "<" "${ROOTDIR}/create_db.sql"
-                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
-                    MAIN_DEPENDENCY "${ROOTDIR}/create_db.sql"
-)
-
 #==================================Qt Junk=====================================
 
 # Create the moc sources from the headers.
@@ -323,7 +319,6 @@
 
 # Generate the resource .cpp from the .qrc file.
 QT4_ADD_RESOURCES(brewtarget_QRC_CPP ${brewtarget_QRC})
-QT4_ADD_RESOURCES(brewtarget_cfg_QRC_CPP ${brewtarget_cfg_QRC})
 
 # Translations
 FIND_PROGRAM( LUPDATE_CMD lupdate-qt4 )
@@ -342,6 +337,8 @@
 
 #============================Icon for Windows==================================
 
+SET(brewtarget_ICON "")
+
 IF( WIN32 AND MINGW )
   ADD_CUSTOM_COMMAND(OUTPUT ${WINDIR}/icon.o
                      COMMAND windres.exe -I${CMAKE_CURRENT_SOURCE_DIR}
@@ -349,15 +346,36 @@
                      -o${WINDIR}/icon.o
                      DEPENDS ${RCFILE}
   )
-  SET(brewtarget_SRCS ${brewtarget_SRCS} ${WINDIR}/icon.o)
+  SET(brewtarget_ICON ${WINDIR}/icon.o)
 ELSEIF(WIN32)
-  SET(brewtarget_SRCS ${brewtarget_SRCS} ${RCFILE})
+  SET(brewtarget_ICON ${RCFILE})
 ENDIF()
 
 #===========================Create the binary==================================
 
-ADD_EXECUTABLE( ${brewtarget_EXECUTABLE} ${brewtarget_SRCS} ${brewtarget_MOC_SRCS} ${brewtarget_QRC_CPP} ${brewtarget_cfg_QRC_CPP} ${brewtarget_UIS_H} )
+# This creates a "library" of object files so that we do not have to recompile
+# the source files once per target, but rather, just once EVER.
+ADD_LIBRARY(
+   btobjlib
+   OBJECT
+   ${brewtarget_SRCS}
+   ${brewtarget_MOC_SRCS}
+   ${brewtarget_QRC_CPP}
+   ${brewtarget_UIS_H}
+)
+
+ADD_EXECUTABLE(
+   ${brewtarget_EXECUTABLE}
+   ${SRCDIR}/main.cpp
+   ${brewtarget_ICON}
+   $<TARGET_OBJECTS:btobjlib>
+)
 ADD_DEPENDENCIES( ${brewtarget_EXECUTABLE} translations )
 
 # Link brewtarget against appropriate libraries.
 IF( WIN32 AND MINGW )
+   ############################################################################
+   # Need to set some linker flags that I don't know how to get
+   # automatically.
+   ############################################################################
+
